//% color="#fa1644" iconWidth=50 iconHeight=40
namespace cnn{

    //% block="初始化tensorflow模块" blockType="command" 
    export function feat_init(parameter: any, block: any){

        Generator.addImport("import tensorflow as tf");
        Generator.addImport("from tensorflow import keras");


    }

    
    //% block="对象名[MOD2]导入模型[MOD1]" blockType="command"
    //% MOD1.shadow="normal"   MOD1.defl="modelname"
    //% MOD2.shadow="normal"   MOD2.defl="model"
    export function mod_load(parameter: any, block: any){
        let mod1 = parameter.MOD1.code
        let mod2 = parameter.MOD2.code
        Generator.addCode(`${mod2} = tf.keras.models.load_model("${mod1}")`)
    }


    //% block="对象名[IMG2]将图片[IMG1]尺寸设置为[SIZ] " blockType="command"
    //% IMG2.shadow="normal"   IMG2.defl="img"
    //% IMG1.shadow="normal"   IMG1.defl="img"
    //% SIZ.shadow="normal"   SIZ.defl="(28, 28)"
    export function resize(parameter: any, block: any){
        let img2 = parameter.IMG2.code
        let img1 = parameter.IMG1.code
        let siz = parameter.SIZ.code
        Generator.addCode(`${img2} = tf.image.resize(${img1}, ${siz})`)
    }


    //% block="对象名[IMG4]将图片[IMG3]转换为数组" blockType="command"
    //% IMG4.shadow="normal"   IMG4.defl="img"
    //% IMG3.shadow="normal"   IMG3.defl="img"
    export function array(parameter: any, block: any){ 
        let img4 = parameter.IMG4.code
        let img3 = parameter.IMG3.code
        Generator.addCode(`${img4} = keras.preprocessing.image.img_to_array(${img3})`);
   
   }

    //% block="在数组[IMG5]末尾增加一维度来匹配模型输入" blockType="command"
    //% IMG5.shadow="normal"   IMG5.defl="img"
    export function expand(parameter: any, block: any){ 
        let img5 = parameter.IMG5.code
        Generator.addCode(`${img5} = tf.expand_dims(${img5}, 0)`)
   
   }



    //% block="将预测结果[PRE]映射到分类[CLA]" blockType="reporter"
    //% PRE.shadow="normal"   PRE.defl="predictions"
    //% CLA.shadow="normal"   CLA.defl="class_names"
    export function map(parameter: any, block: any){ 
        let pre = parameter.PRE.code
        let cla = parameter.CLA.code
        Generator.addImport("from tensorflow import keras");
        Generator.addCode(`str(${cla}[${pre}.numpy().argmax()])`)
   
   }

    //% block="对象名[PRE2]用模型[MOD3]预测图片[IMG7]" blockType="command"
    //% PRE2.shadow="normal"   PRE2.defl="predictions"
    //% IMG7.shadow="normal"   IMG7.defl="img"
    //% MOD3.shadow="normal"   MOD3.defl="model"
    export function predict(parameter: any, block: any){ 
        let pre2 = parameter.PRE2.code
        let img7 = parameter.IMG7.code
        let mod3 = parameter.MOD3.code
        Generator.addCode(`${pre2} = ${mod3}.predict(${img7}) `);
   
   }

    //% block="输出[PRE3]预测结果" blockType="command"
    //% PRE3.shadow="normal"   PRE3.defl="predictions"
    export function predict_output(parameter: any, block: any){ 
        let pre3 = parameter.PRE3.code
        Generator.addCode(`${pre3} = tf.nn.softmax(${pre3})`)
   
   }
}